<!doctype html>
<html>
<head>
  <meta charset="utf-8">
  <title>Langton Ant</title>
</head>
  <script src="ca.js"></script>
<body>

  <canvas id="canvas" width="1000" height="1000"></canvas>
   
  <script type="text/javascript">
    "use strict";

    const canvas = document.getElementById("canvas");

    const context = canvas.getContext("2d");
    context.scale(2,2);

    function newState(color) {
	return {
	    color: color,
	    ant: undefined,
	};
    }

    function initLangton( w, h ) {
        let w2 = Math.ceil(w/2);
        let h2 = Math.ceil(h/2);
	return function(x,y) {
	    let state = newState("white");
	    if( x === w2 && y === h2 ) {
		state.ant = "N";
	    }
	    return state;
	}
    }

    function langton1( x, y, c ) {
	let cur = c[x][y];
	let next = newState( cur.color );
	if( c[x][y].ant !== undefined ) {
	    if( cur.color === "white" ) {
		next.color ="black";
	    } else
		next.color ="white";
	}
	if( c[x-1][y].ant === "N" && c[x-1][y].color === "white" ) {
	    next.ant = "E";
	}
	if( c[x-1][y].ant === "S" && c[x-1][y].color === "black" ) {
	    next.ant = "E";
	}
	if( c[x+1][y].ant === "N" && c[x+1][y].color === "black" ) {
	    next.ant = "W";
	}
	if( c[x+1][y].ant === "S" && c[x+1][y].color === "white" ) {
	    next.ant = "W";
	}
	if( c[x][y+1].ant === "W" && c[x][y+1].color === "black" ) {
	    next.ant = "S";
	}
	if( c[x][y+1].ant === "E" && c[x][y+1].color === "white" ) {
	    next.ant = "S";
	}
	if( c[x][y-1].ant === "E" && c[x][y-1].color === "black" ) {
	    next.ant = "N";
	}
	if( c[x][y-1].ant === "W" && c[x][y-1].color === "white" ) {
	    next.ant ="N";
	}
	return next;
    }

    function langtonColor(state) {
        let color = state.color;
	if( state.ant !== undefined ) {
	    color = "red";
	}
        return color;
    }

    console.log("INIT");
    const width = 100;
    const height = 100;
    let cells = setup( width, height, initLangton( width, height) );

    console.log("RUN");
    const delay = 0; //In millisec.
    const iter = 10000;
    start( context, cells, langton1, langtonColor, iter, delay );

    console.log("DONE");

  </script>
</body>
</html>



